com.fasterxml.jackson.databind.ser.std

## Class JsonValueSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<Object>
    - - com.fasterxml.jackson.databind.ser.std.JsonValueSerializer

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable

    public class JsonValueSerializer
    extends StdSerializer<Object>
    implements ContextualSerializer, JsonFormatVisitable

Serializer class that can serialize Object that have a `JsonValue` annotation to indicate that serialization should be done by calling the method annotated, and serializing result it returns.

Implementation note: we will post-process resulting serializer (much like what is done with `BeanSerializer`) to figure out actual serializers for final types. This must be done from `createContextual(com.fasterxml.jackson.databind.SerializerProvider, com.fasterxml.jackson.databind.BeanProperty)` method, and NOT from constructor; otherwise we could end up with an infinite loop.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

Fields
`protected AnnotatedMember` `_accessor`
`protected PropertySerializerMap` `_dynamicSerializers` If value type cannot be statically determined, mapping from runtime value types to serializers are cached in this object.
`protected boolean` `_forceTypeInformation` This is a flag that is set in rare (?) cases where this serializer is used for "natural" types (boolean, int, String, double); and where we actually must force type information wrapping, even though one would not normally be added.
`protected BeanProperty` `_property`
`protected JsonSerializer<Object>` `_valueSerializer`
`protected JavaType` `_valueType` Declared type of the value accessed, as declared by accessor.
`protected TypeSerializer` `_valueTypeSerializer`

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
Constructor and Description
`JsonValueSerializer(AnnotatedMember accessor, JsonSerializer<?> ser)` Deprecated. Since 2.12
`JsonValueSerializer(AnnotatedMember accessor, TypeSerializer vts, JsonSerializer<?> ser)`
`JsonValueSerializer(JsonValueSerializer src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> ser, boolean forceTypeInfo)`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`protected boolean` `_acceptJsonFormatVisitorForEnum(JsonFormatVisitorWrapper visitor, JavaType typeHint, Class<?> enumType)` Overridable helper method used for special case handling of schema information for Enums.
`protected JsonSerializer<Object>` `_findDynamicSerializer(SerializerProvider ctxt, Class<?> valueClass)`
`void` `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
`JsonSerializer<?>` `createContextual(SerializerProvider ctxt, BeanProperty property)` We can try to find the actual serializer for value, if we can statically figure out what the result type must be.
`JsonNode` `getSchema(SerializerProvider ctxt, Type typeHint)` Deprecated. Since 2.15
`boolean` `isEmpty(SerializerProvider ctxt, Object bean)` Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`protected boolean` `isNaturalTypeWithStdHandling(Class<?> rawType, JsonSerializer<?> ser)`
`void` `serialize(Object bean, JsonGenerator gen, SerializerProvider ctxt)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`void` `serializeWithType(Object bean, JsonGenerator gen, SerializerProvider ctxt, TypeSerializer typeSer0)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
`String` `toString()`
`protected JsonValueSerializer` `withResolved(BeanProperty property, TypeSerializer vts, JsonSerializer<?> ser, boolean forceTypeInfo)`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_neitherNull, _nonEmpty, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findContextualConvertingSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isEmpty, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### _accessor

    protected final AnnotatedMember _accessor

Since:
  2.9

#### _valueTypeSerializer

    protected final TypeSerializer _valueTypeSerializer

Since:
  2.12

#### _valueSerializer

    protected final JsonSerializer<Object> _valueSerializer

#### _property

    protected final BeanProperty _property

#### _valueType

    protected final JavaType _valueType

Declared type of the value accessed, as declared by accessor.

Since:
  2.12

#### _forceTypeInformation

    protected final boolean _forceTypeInformation

This is a flag that is set in rare (?) cases where this serializer is used for "natural" types (boolean, int, String, double); and where we actually must force type information wrapping, even though one would not normally be added.

#### _dynamicSerializers

    protected transient PropertySerializerMap _dynamicSerializers

If value type cannot be statically determined, mapping from runtime value types to serializers are cached in this object.

Since:
  2.12

### Constructor Detail

#### JsonValueSerializer

    public JsonValueSerializer(AnnotatedMember accessor,
                               TypeSerializer vts,
                               JsonSerializer<?> ser)

Parameters:
  `ser` - Explicit serializer to use, if caller knows it (which occurs if and only if the "value method" was annotated with `JsonSerialize.using()`), otherwise null
Since:
  2.12 added `TypeSerializer` since 2.11

#### JsonValueSerializer

    @Deprecated
    public JsonValueSerializer(AnnotatedMember accessor,
                                           JsonSerializer<?> ser)

Deprecated. Since 2.12

#### JsonValueSerializer

    public JsonValueSerializer(JsonValueSerializer src,
                               BeanProperty property,
                               TypeSerializer vts,
                               JsonSerializer<?> ser,
                               boolean forceTypeInfo)

### Method Detail

#### withResolved

    protected JsonValueSerializer withResolved(BeanProperty property,
                                               TypeSerializer vts,
                                               JsonSerializer<?> ser,
                                               boolean forceTypeInfo)

#### isEmpty

    public boolean isEmpty(SerializerProvider ctxt,
                           Object bean)

Description copied from class: `JsonSerializer`
Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

NOTE: replaces `JsonSerializer.isEmpty(Object)`, which was deprecated in 2.5

Overrides:
  `isEmpty` in class `JsonSerializer<Object>`

#### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider ctxt,
                                              BeanProperty property)
                                       throws JsonMappingException

We can try to find the actual serializer for value, if we can statically figure out what the result type must be.

Specified by:
  `createContextual` in interface `ContextualSerializer`
Parameters:
  `ctxt` - Serializer provider to use for accessing config, other serializers
  `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
Returns:
  Serializer to use for serializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### serialize

    public void serialize(Object bean,
                          JsonGenerator gen,
                          SerializerProvider ctxt)
                   throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Specified by:
  `serialize` in class `StdSerializer<Object>`
Parameters:
  `bean` - Value to serialize; can not be null.
  `gen` - Generator used to output resulting Json content
  `ctxt` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### serializeWithType

    public void serializeWithType(Object bean,
                                  JsonGenerator gen,
                                  SerializerProvider ctxt,
                                  TypeSerializer typeSer0)
                           throws IOException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

      // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
      typeSer.writeTypePrefixForScalar(value, gen);
      serialize(value, gen, provider);
      typeSer.writeTypeSuffixForScalar(value, gen);

and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY`/`END-ARRAY` and `START-OBJECT`/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.

Overrides:
  `serializeWithType` in class `JsonSerializer<Object>`
Parameters:
  `bean` - Value to serialize; can not be null.
  `gen` - Generator used to output resulting Json content
  `ctxt` - Provider that can be used to get serializers for serializing Objects value contains, if any.
  `typeSer0` - Type serializer to use for including type information
Throws:
  `IOException`

#### getSchema

    @Deprecated
    public JsonNode getSchema(SerializerProvider ctxt,
                                          Type typeHint)
                                   throws JsonMappingException

Deprecated. Since 2.15
Description copied from class: `StdSerializer`
Default implementation simply claims type is "string"; usually overriden by custom serializers.

Specified by:
  `getSchema` in interface `SchemaAware`
Overrides:
  `getSchema` in class `StdSerializer<Object>`
Parameters:
  `ctxt` - The serializer provider.
  `typeHint` - A hint about the type.
Returns:
  Json-schema for this serializer.
Throws:
  `JsonMappingException`

#### acceptJsonFormatVisitor

    public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                                        JavaType typeHint)
                                 throws JsonMappingException

Description copied from class: `StdSerializer`
Default implementation specifies no format. This behavior is usually overriden by custom serializers.

Specified by:
  `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
Overrides:
  `acceptJsonFormatVisitor` in class `StdSerializer<Object>`
  `typeHint` - Type of element (entity like property) being visited
Throws:
  `JsonMappingException`

#### _acceptJsonFormatVisitorForEnum

    protected boolean _acceptJsonFormatVisitorForEnum(JsonFormatVisitorWrapper visitor,
                                                      JavaType typeHint,
                                                      Class<?> enumType)
                                               throws JsonMappingException

Overridable helper method used for special case handling of schema information for Enums.

Returns:
  True if method handled callbacks; false if not; in latter case caller will send default callbacks
Throws:
  `JsonMappingException`
Since:
  2.6

#### isNaturalTypeWithStdHandling

    protected boolean isNaturalTypeWithStdHandling(Class<?> rawType,
                                                   JsonSerializer<?> ser)

#### _findDynamicSerializer

    protected JsonSerializer<Object> _findDynamicSerializer(SerializerProvider ctxt,
                                                            Class<?> valueClass)
                                                     throws JsonMappingException

Throws:
  `JsonMappingException`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`